package audio;

import bench.Timer;
import grapher.Dl;
import grapher.Graph;
import gui.Evt;
import observers.IntDialog;
import observers.ObservableInt;

import java.awt.*;


public class AudioFrame extends OscopeFrame {


    private Oscillator osc =

            new Oscillator(400, 1024);

    // relative frequency is

    // the frequency / fs

    // f, N



    UlawCodec ulc;

    FFT fftInstance;


    private ObservableInt endPositionOfSamplesToGraph;

    private ObservableInt startPositionOfSamplesToGraph;

    private final double pi_2 = Math.PI * 2;

    private final double pi = Math.PI;

    private final double samplingRate = 8000.0;

    private final double frequency = 440.0;


    Menu m = new Menu("Audio Menu");


    MenuItem openAu_mi = addMenuItem(m, "[o] Open Au");

    MenuItem saveSound_mi = addMenuItem(m, "[v] Save As ...");

    MenuItem graphUlaw_mi = addMenuItem(m, "[u] ulaw graph ");

    MenuItem graphSound_mi = addMenuItem(m, "[g] graph sound");

    MenuItem play_mi = addMenuItem(m, "[p] Play");

    MenuItem print_mi = addMenuItem(m, "[P] Print Components");

    MenuItem reverse_mi = addMenuItem(m, "[r] Reverse");

    MenuItem sineWave_mi = addMenuItem(m, "[s] Sine wave");

    MenuItem sawWave_mi = addMenuItem(m, "[^] Saw wave");

    MenuItem triangleWave_mi = addMenuItem(m, "[T] Triangle wave");

    MenuItem squareWave_mi = addMenuItem(m, "[[] Square wave");

    MenuItem timeDelay_mi = addMenuItem(m, "[t] time delay");

    MenuItem normalize_mi = addMenuItem(m, "[n] normalize");

    MenuItem am_mi = addMenuItem(m, "[m] AM");

    MenuItem fm_mi = addMenuItem(m, "[f] FM");

    MenuItem fft_mi = addMenuItem(m, "[1] FFT");

    MenuItem ifft_mi = addMenuItem(m, "[2] IFFT");

    MenuItem dft_mi = addMenuItem(m, "[3] DFT");

    MenuItem idft_mi = addMenuItem(m, "[4] IDFT");

    MenuItem graphPSD_mi = addMenuItem(m, "[5] Graph PSD, R and I");

    MenuItem makePulse_mi = addMenuItem(m, "[6] Make a pulse");

    MenuItem makeNotch_mi = addMenuItem(m, "[7] Make a notch");

    MenuItem makeHanning_mi = addMenuItem(m, "[8] Make hanning");

    MenuItem makeBartlett_mi = addMenuItem(m, "[M] Make Bartlett");

    MenuItem makeLyon_mi = addMenuItem(m, "[L] Make Lyon");

    MenuItem multLyon_mi = addMenuItem(m, "[*] Mult Lyon");

    MenuItem multHanning_mi = addMenuItem(m, "[9] Mult hanning");

    MenuItem multBartlett_mi = addMenuItem(m, "[B] Mult Bartlett");

    MenuItem addNoise_mi = addMenuItem(m, "[A] Add Noise");

    MenuItem removeNoise_mi = addMenuItem(m, "[R] Remove Noise");

    MenuItem lowpass_mi = addMenuItem(m, "[l] low pass filter");

    MenuItem highpass_mi = addMenuItem(m, "[l] high pass filter");

    MenuItem pitchShift_mi = addMenuItem(m, "[S] Pitch Shift");

    MenuItem resample_mi = addMenuItem(m, "[w] Resample 2:1");

    MenuItem parameters_mi = addMenuItem(m, "[P] Set Parameters...");


    public AudioFrame(String name) {

        super(name);

        // Init_menu requires that the fileName be set

        // for the frame title.

        init_menu();

        endPositionOfSamplesToGraph =

                new ObservableInt(ulc.getLength(), "endPositionOfSamplesToGraph");

        startPositionOfSamplesToGraph =

                new ObservableInt(0, "startPositionOfSamplesToGraph");


    }

    public static void main(String args[]) {

        AudioFrame af = new AudioFrame("test frame");

    }


    void test() {

        System.out.println("u_law test:");

        System.out.println("b7 = p = sign bit");

        System.out.println("b6,b5,b4 = s2 s1 s0 = segment");

        System.out.println("b3,b2,b1,b0 = q3, q2, q1, q0 = step selction");

        System.out.println("pSSSQQQQ");

        System.out.println("76543210");

        for (double t = -1; t < 1; t = t + 0.1) {


            System.out.println(Integer.toString(Ulaw.toUlaw(t), 2));

        }

    }


    public void saveAs() {

        ulc.writeAUFile();

    }


    public boolean handleEvent(Event e) {


        if (Evt.match(e, resample_mi)) {

            resample();

            return true;

        }

        if (Evt.match(e, pitchShift_mi)) {

            pitchShift();

            return true;

        }

        if (Evt.match(e, multLyon_mi)) {

            multLyon();

            return true;

        }

        if (Evt.match(e, makeBartlett_mi)) {

            makeBartlett();

            return true;

        }

        if (Evt.match(e, makeLyon_mi)) {

            makeLyon();

            return true;

        }

        if (Evt.match(e, multBartlett_mi)) {

            multBartlett();

            return true;

        }

        if (Evt.match(e, multHanning_mi)) {

            multHanning();

            return true;

        }

        if (Evt.match(e, makeHanning_mi)) {

            makeHanning();

            return true;

        }

        if (Evt.match(e, makePulse_mi)) {

            makePulse();

            return true;

        }


        if (Evt.match(e, makeNotch_mi)) {

            makeNotch();

            return true;

        }


        if (Evt.match(e, addNoise_mi)) {

            addNoise();

            return true;

        }


        if (Evt.match(e, removeNoise_mi)) {

            removeNoise();

            return true;

        }

        if (Evt.match(e, saveSound_mi)) {

            saveAs();

            return true;

        }

        if (Evt.match(e, lowpass_mi)) {

            lowpass();

            return true;

        }

        if (Evt.match(e, highpass_mi)) {

            highpass();

            return true;

        }

        if (Evt.match(e, print_mi)) {

            validate();

            list(System.out, 5);

            return true;

        }


        if (Evt.match(e, parameters_mi)) {

            IntDialog w = new IntDialog(

                    "Samples dialog",

                    "Enter end Position Of Samples To Graph:",

                    endPositionOfSamplesToGraph

            );

            IntDialog spDialog = new IntDialog(

                    "start Position Of Samples To Graph dialog",

                    "Enter start position:",

                    startPositionOfSamplesToGraph

            );

            return true;

        }

        if (Evt.match(e, fft_mi)) {

            fft();

            return true;

        }

        if (Evt.match(e, ifft_mi)) {

            ifft();

            return true;

        }


        if (Evt.match(e, dft_mi)) {

            fftInstance = dft();

            return true;

        }

        if (Evt.match(e, idft_mi)) {

            idft(fftInstance);

            return true;

        }


        if (Evt.match(e, graphPSD_mi)) {

            graphPSD();

            return true;

        }


        if (Evt.match(e, normalize_mi)) {

            normalize();

            return true;

        }

        if (Evt.match(e, am_mi)) {

            am();

            return true;

        }

        if (Evt.match(e, fm_mi)) {

            fm();

            return true;

        }

        if (Evt.match(e, play_mi)) {

            play();

            return true;

        }


        if (Evt.match(e, graphSound_mi)) {

            graphSound();

            return true;

        }


        if (Evt.match(e, sineWave_mi)) {

            sineWave();

            return true;

        }

        if (Evt.match(e, squareWave_mi)) {

            squareWave();

            return true;

        }

        if (Evt.match(e, sawWave_mi)) {

            sawWave();

            return true;

        }

        if (Evt.match(e, triangleWave_mi)) {

            triangleWave();

            return true;

        }

        if ((Evt.match(e, graphUlaw_mi))) {

            graphUlaw();

            return true;

        }

        if (Evt.match(e, openAu_mi)) {

            openDataFile();

            return true;

        }


        if (Evt.match(e, timeDelay_mi)) {

            timeDelay();

            return true;

        }

        if (Evt.match(e, reverse_mi)) {

            //ulawData = Audio.reverse(ulawData);

            ulc.reverseUlaw();

            return true;

        }


        return super.handleEvent(e);

    }


    public void am() {

        osc.setModulationIndex(0.5d);

        osc.setModulationFrequency(200d);

        ulc = new UlawCodec(

                osc.getAM());

        play();

    }


    public void fm() {

        osc.setModulationIndex(0.5d);

        osc.setModulationFrequency(200d);

        ulc = new UlawCodec(

                osc.getFM());

        play();

    }


    public void sineWave() {

        ulc = new UlawCodec(

                osc.getSineWave());

        play();

    }

    public void squareWave() {

        ulc = new UlawCodec(

                osc.getSquareWave());

        play();

    }

    public void sawWave() {

        ulc = new UlawCodec(

                osc.getSawWave());

        play();

    }

    public void triangleWave() {

        ulc = new UlawCodec(

                osc.getTriangleWave());

        play();

    }


    public void timeDelay() {

        double s1,s2,s3;

        int delay = 100;

        int delay3 = 1000;

        double[] doubleData = ulc.getDoubleArray();

        for (int i = 0; i < doubleData.length; i++) {

            s1 = doubleData[i];

            s2 = 0;

            s3 = 0;

            if (i > delay) {
                s2 = doubleData[i - delay];
            }

            if (i > delay3) {
                s3 = doubleData[i - delay3];
            }


            doubleData[i] = (s3 + s2 + s1) / 3;

        }

        ulc = new UlawCodec(doubleData);

        play();

    }


    public void play(int i) {

        for (int k = 0; k < i; k++) {

            play();

        }

    }


    public void play() {

        ulc = new UlawCodec(ulc.getDoubleArray());

        ulc.play();

    }


    double numberOfCycles() {

        return ulc.getDuration() * frequency;

    }



    // when delta_t*length = numberOfCycles

    double delta_t() {

        return numberOfCycles() / ulc.getLength();

    }


    public void init_menu() {

        MenuBar mb = getMenuBar();

        mb.add(m);

        show();

    }


    public void buildAudioDataDouble(Dl ad) {

        double[] doubleData = ulc.getDoubleArray();

        int endPosition = endPositionOfSamplesToGraph.getValue();

        int startPosition = startPositionOfSamplesToGraph.getValue();

        // Assume we have 8,000 samples per second

        // Then x's start position and increment

        // are computed as:

        int index = 0;

        for (int i = startPosition; i < endPosition; i++) {

            ad.x_data[index] = i;

            ad.y_data[index] = doubleData[i];

            index++;

        }

    } // buildAudioData


    public void graphUlaw() {

        int endPosition = endPositionOfSamplesToGraph.getValue();

        int startPosition = startPositionOfSamplesToGraph.getValue();

        byte ulawData[] = ulc.getUlawData();

        // Make a graph of the Ulaw encoded data

        int request = endPosition;

        // do some error checking.

        // Does the user want more samples than we have?

        if (request > ulc.getLength()) {

            request = ulawData.length;

            endPositionOfSamplesToGraph.setValue(request);

        }

        int length = request - startPosition;

        double yData[] = new double[length];

        int index = startPosition;

        for (int i = 0; i < length; i++) {

            yData[i] =

                    (double) ulawData[index];

            if (yData[i] < 0)

                yData[i] = 50 - yData[i];

            index++;

            if (index == request) break;

        }

        Graph.graph(yData, "sample number", "u-law");


    }


    public boolean mouseUp(Event e, int x, int y) {

        repaint();

        return false;

    }


    public void normalize() {

        Audio a = new Audio(ulc.getDoubleArray());

        a.normalize();

        ulc = new UlawCodec(a.getAudioData());

        play();

    }

    public double[] getDoubleData() {

        return ulc.getDoubleArray();

    }


    public void openDataFile() {

        ulc = new UlawCodec();

        setDoubleData(ulc.getDoubleArray());

        ulc.play();

    }


    public void graphSound() {

        new DoubleGraph(ulc.getDoubleArray(), "Sound");

    }


    public FFT dft() {


        double doubleArray[] = ulc.getDoubleArray();


        double[] psd;


        FFT f = new FFT();


        Timer t1 = new Timer();

        t1.mark();


        psd = f.dft(doubleArray);



        // Stop the timer and report.

        t1.record();

        System.out.println("Time to perform DFT:");

        t1.report();


        f.graphs();

        //doubleData = f.r_data;

        new DoubleGraph(psd, "psd");

        return f;


    }

    public void idft(FFT f) {


        double doubleArray[];


        Timer t1 = new Timer();

        t1.mark();


        doubleArray = f.idft();



        // Stop the timer and report.

        t1.record();

        System.out.println("Time to perform IDFT:");

        t1.report();


        f.graphs();

        //doubleData = f.r_data;

        new DoubleGraph(doubleArray, "v");


    }


    double[] getTruncatedDoubleData() {

        double[] temp = FFT.arrayCopy(getDoubleData());


        int trunc = 1 << FFT.log2(temp.length);

        System.out.println("Truncated size: " + trunc);

        double[] truncArray = new double[trunc];


        for (int i = 0; i < trunc; i++)

            truncArray[i] = temp[i];


        return truncArray;


    }


    public void fft() {


        fftInstance = new FFT();

        double[] r_d = getTruncatedDoubleData();

        double[] i_d = new double[r_d.length];

        fftInstance.forwardFFT(r_d, i_d);

        ulc.play();


    }


    public void removeNoise() {

        double noisePowerCutoff = 0.05;


        fftInstance = new FFT();

        double r_d[] = getTruncatedDoubleData();

        double i_d[] = new double[r_d.length];

        fftInstance.forwardFFT(r_d, i_d);


        double psd[] = fftInstance.computePSD();

        for (int i = 0; i < psd.length; i++) {

            if (psd[i] < noisePowerCutoff) {

                r_d[i] = 0;

                i_d[i] = 0;

            }

        }


        fftInstance.reverseFFT(r_d, i_d);


        ulc = new UlawCodec(r_d);


        ulc.play();


    }


    public void makeNotch() {

        double r_d[] = new double[256];

        int center = r_d.length / 2;

        int pulseWidth = 5;

        int start = center - pulseWidth;

        int end = center + pulseWidth;

        String b = ",";

        System.out.println("Center, Start, End:" + center + b + start + b + end);

        for (int i = 0; i < r_d.length; i++) {

            r_d[i] = 0.98;

        }


        for (int i = start; i < end; i++) {

            r_d[i] = 0;

        }

        ulc = new UlawCodec(r_d);


    }

    public void makePulse() {

        double r_d[] = new double[256];

        int center = r_d.length / 2;

        int pulseWidth = 10;

        int start = center - pulseWidth;

        int end = center + pulseWidth;

        String b = ",";

        System.out.println("Center, Start, End:" + center + b + start + b + end);


        for (int i = start; i < end; i++) {

            r_d[i] = 0.98;

        }

        ulc = new UlawCodec(r_d);


    }


    public void makeBartlett() {

        double window[];

        window = makeBartlett(256);

        Graph.graph(window,

                "Bartlett", "f");

    }


    public double[] makeBartlett(int n) {

        double window[] = new double[n];


        double a = 2.0 / (n - 1);


        for (int i = 0; i < n / 2; i++)

            window[i] = i * a;


        for (int i = n / 2; i < n; i++)

            window[i] = 2.0 - i * a;


        return window;


    }


    public void multBartlett() {

        double[] r_d = getTruncatedDoubleData();

        double[] window = makeBartlett(r_d.length);


        windowAudio(r_d, window, "Bartlett");


    }


    public void multLyon() {

        double[] r_d = getTruncatedDoubleData();

        double[] window = makeLyon(r_d.length);


        windowAudio(r_d, window, "Lyon");

    }


    public void makeLyon() {

        double window[];

        window = makeLyon(256);

        Graph.graph(window,

                "The Lyon window", "f");

    }


    public double y5(double y0, double y1, double u) {

        double t2 = u * u;

        double t3 = t2 * t2;

        return

                (6 * y1 - 6 * y0) * t3 * u +

                (-15 * y1 + 15 * y0) * t3 +

                (10 * y1 - 10 * y0) * t2 * u + y0;

    }


    public double[] makeLyon(int n) {

        double window[] = new double[n];


        double u = 0.0;

        double du = 2.0 / n;

        for (int i = 0; i < n / 2; i++) {

            window[i] = y5(0, 1.0, u);

            u += du;

        }

        u = 0;


        for (int i = n / 2; i < n; i++) {

            window[i] = y5(1.0, 0.0, u);

            u += du;

        }

        return window;


    }


    public void windowAudio(double r_d[], double window[], String title) {

        windowArray(window, r_d);

        ulc = new UlawCodec(r_d);


        Graph.graph(r_d,

                title, "a");

        ulc.play();


    }


    public void makeHanning() {

        double window[];

        window = makeHanning(256);

        Graph.graph(window,

                "The Hanning window", "f");

    }


    public double[] makeHanning(int n) {

        double window[] = new double[n];


        double arg = 2.0 * Math.PI / (n - 1);


        for (int i = 0; i < n; i++)

            window[i] = 0.5 - 0.5 * Math.cos(arg * i);


        return window;


    }


    public void multHanning() {

        double[] r_d = getTruncatedDoubleData();

        double[] window = makeHanning(r_d.length);


        windowAudio(r_d, window, "hanning");

    }


    public void windowArray(double window[], double r_d[]) {

        for (int i = 0; i < window.length; i++) {

            r_d[i] *= window[i];

        }

    }


    public void windowArrays(double window[], double r_d[], double i_d[]) {

        for (int i = 0; i < window.length; i++) {

            r_d[i] *= window[i];

            i_d[i] *= window[i];

        }

    }


    public void addNoise() {

        double r_d[] = getDoubleData();

        for (int i = 0; i < r_d.length; i++)

            r_d[i] = r_d[i] + 0.1 * (Math.random() - 0.5);

        ulc = new UlawCodec(r_d);

    }


    public void lowpass() {


        fftInstance = new FFT();

        double[] r_d = getTruncatedDoubleData();

        double[] i_d = new double[r_d.length];

        fftInstance.forwardFFT(r_d, i_d);


        int N = r_d.length;

        int center = N / 2;

        int f0 = center - center / 2;

        int f1 = center + center / 2;

        int f2 = 0;

        int f3 = 0;

        filter(f0, f1, f2, f3, r_d, i_d);


    }



// zero elements between f0,f1 and f2,f3

    public void filter(int f0, int f1, int f2, int f3, double r_d[], double i_d[]) {

        System.out.println("Zeroing elements " + f0 + " through " + f1);

        System.out.println("Zeroing elements " + f2 + " through " + f3);


        for (int i = f0; i < f1; i++) {

            r_d[i] = 0;

            i_d[i] = 0;


        }

        for (int i = f2; i < f3; i++) {

            r_d[i] = 0;

            i_d[i] = 0;


        }


        fftInstance.reverseFFT(r_d, i_d);


        ulc = new UlawCodec(r_d);


        ulc.play();


    }

    public void highpass() {


        fftInstance = new FFT();

        double[] r_d = getTruncatedDoubleData();

        double[] i_d = new double[r_d.length];

        fftInstance.forwardFFT(r_d, i_d);


        int N = r_d.length;

        int center = N / 2;

        int f0 = 0;

        int f1 = center - center / 2;

        int f2 = N - center / 2;

        int f3 = N;

        filter(f0, f1, f2, f3, r_d, i_d);


    }


    public void resample() {

        double[] r_d = getTruncatedDoubleData();

        int N = r_d.length;

        double[] resampled = new double[N / 2];

        for (int i = 0; i < N / 2; i++)

            resampled[i] = r_d[2 * i];


        ulc = new UlawCodec(resampled);


        ulc.play();


    }


    public void pitchShift() {

        fftInstance = new FFT();

        double[] r_d = getTruncatedDoubleData();

        int N = r_d.length;

        double[] i_d = new double[N];

        int N_on_4 = N / 4;


        fftInstance.forwardFFT(r_d, i_d);

        // shift data down

        for (int i = 0; i < N_on_4; i++) {

            r_d[i] = r_d[i + N_on_4];

            i_d[i] = i_d[i + N_on_4];

        }

        for (int i = N_on_4; i < N / 2; i++) {

            r_d[i] = 0;

            i_d[i] = 0;

        }



        // reflect about center, assuming a real signal

        int i,j;

        for (i = 0, j = N - 1; i < N / 2; i++, j--) {

            r_d[j] = r_d[i];

            i_d[j] = i_d[i];

        }


        fftInstance.reverseFFT(r_d, i_d);


        ulc = new UlawCodec(r_d);


        ulc.play();


    }


    public void ifft() {


        double realInput[] =

                FFT.arrayCopy(fftInstance.getReal());

        double imaginaryInput[] =

                FFT.arrayCopy(fftInstance.getImaginary());


        fftInstance.reverseFFT(realInput, imaginaryInput);


        ulc = new UlawCodec(realInput);


        ulc.play();


    }


    public static void logArray(double a[]) {

        for (int i = 0; i < a.length; i++) {

            a[i] = 10 * Math.log(a[i]);

        }

    }


    public void graphPSD() {

        double psd[] = fftInstance.computePSD();

        //logArray(psd);

        Graph.graph(psd, "psd", "a^2");

    }


    public void graphPSD_zoom() {

        double psd[] = fftInstance.computePSD();

        double shortPsd[] = new double[200];

        for (int i = 0; i < shortPsd.length; i++) {

            shortPsd[i] = 10 * Math.log(Math.sqrt(psd[i]));

        }

        Graph.graph(shortPsd, "spectral mag", "a dB");

    }


    public void graphs() {

        Graph.graph(fftInstance.getReal(),

                "real of truncated waveform", "a");


        Graph.graph(fftInstance.getImaginary(),

                "imaginary of truncated waveform", "a");


        double psd[] = fftInstance.computePSD();


        Graph.graph(psd,

                "PSD of truncated waveform", "a^2");

    }


}

