package diffcad;

import futils.Print;
import observers.ObservableDouble;

import java.awt.*;

class Grating extends Shape {

    //double pitch1 = 6300; // nm
    // double pitch2 = 2200; // nm
    // double pitch1 = 5000; // nm
    // double pitch2 = 5000; // nm

    // extant grating
    private ObservableDouble pitch1 = new
            ObservableDouble(581, "ax**2 + x/2 + c,c="); // nm
    private ObservableDouble pitch2 = new
            ObservableDouble(0.059, "ax**2 + x/2 + c,a="); // nm
    public double L = 96; // mm

    void setPitch(int v1, int v2) {
        pitch1.setValue(v1);
        pitch2.setValue(v2);
    }

    public ObservableDouble getPitch2() {
        return pitch2;
    }

    public ObservableDouble getPitch1() {
        return pitch1;
    }

    // given a dilation parameter, return a valid pitch
    double pitch(double t) {
        double a = pitch1.getValue();
        double b = -0.5;
        double c = pitch2.getValue();
        double x = t * L;
        double x2 = x * x;
        return a * x2 + b * x + c;
    }

    void change_config(double length) {
        L = length;
    }

    void change_config(point t) {
        L = L + t.x;
    }

    void print() {
        Print.className(this);
        print("P1=\t" + pitch1.getValue() + "\t" + "P2=\t" + pitch2.getValue() + "\t");
        Print.ln("L=\t" + L);
        for (double t = 0; t < L; t = t + 1)
            System.out.println("P:" + pitch(t));
    }

    void draw(Graphics g) {
        pushGraphicsState(g);
        p2.x = p1.x + L;
        p2.y = p1.y;
        line(g, p1, p2);
        string(g, "G1", p1);
        string(g, "G2", p2);
        popGraphicsState(g);
    }
}




