package diffcad;

import futils.Cat;
import futils.DirList;
import futils.Futil;
import futils.Ls;
import bench.Benchmark;
import fonts.FontViewer;
import dumper.Dump;
import gui.ColorGridFrame;
import gui.Evt;
import gui.SciCalc;
import htmlconverter.HtmlGenerator;
import ipl.ImageFrame;
import audio.AudioFrame;
import net.CheckMail;
import net.SendMail;
import observers.DoubleDialog;
import observers.IntDialog;
import threads.RaceThread;

import java.awt.*;
import java.io.IOException;
import java.io.OutputStream;

public abstract class ProcessMenuItem {

    static Grating g = (Grating) Geometry.grating;
    static Camera c = (Camera) Geometry.camera;

// left af out here so the gc doesn't eat it!
    static AudioFrame af;


    public static void objects(MenuBarFrame f, Event e) {
        // System.out.println("Process_menuitem called with "+arg);

        if (Evt.match(e, "ls */*>foo")) {
            String args[] = {""};
            DirList.main(args);
        }
        if (Evt.match(e, "Audio Processing")) {
            System.out.println("Audio Processing on...");
            af = new AudioFrame("Audio Frame");
        }

        if (Evt.match(e, "Open Vectors")) {
            DrawVector w = new DrawVector();
            String args[] = {};
            w.main(args);
        }

        if (Evt.match(e, "htmlGenerator")) {
            HtmlGenerator hg =
                    new HtmlGenerator("The HTML Generator");
            hg.main(null);
        }
        if (Evt.match(e, "list properties")) {
            System.getProperties().list(System.out);
        }

        if (Evt.match(e, "benchmark")) {

            String args[] = {};
            Benchmark.main(args);
        }


        if (Evt.match(e, "Thread Monitor")) {
            RaceThread r = new RaceThread();
            r.start();
        }

        if (Evt.match(e, "CheckMail")) {
            CheckMail w = new
                    CheckMail();
            String title = (String) e.arg;
            String args[] = {""};
            w.main(args);
        }
        if (Evt.match(e, "SendMail")) {
            SendMail w = new
                    SendMail();
            String title = (String) e.arg;
            String args[] = {""};
            w.main(args);
        }


        if (Evt.match(e, "dump_class")) {
            Dump w = new
                    Dump(Futil.getReadFileName());
        }

        if (Evt.match(e, "Image Processing")) {
            ImageFrame w = new ImageFrame();
        }

        if (Evt.match(e, "Toy Calculator"))
            AppletUtil.run(new SciCalc());

        if (Evt.match(e, "color grid")) {
            ColorGridFrame w = new ColorGridFrame(f, Geometry.grid);
            w.setTitle((String) e.arg);
        }

        if (Evt.match(e, "color camera")) {
            ColorGridFrame w = new ColorGridFrame(f, Geometry.camera);
            w.setTitle((String) e.arg);
        }

        if (Evt.match(e, "color laser")) {
            ColorGridFrame w = new ColorGridFrame(f, Geometry.laser);
            w.setTitle((String) e.arg);
        }

        if (Evt.match(e, "color wedge")) {
            ColorGridFrame w = new ColorGridFrame(f, Geometry.wedge);
            w.setTitle((String) e.arg);
        }

        if (Evt.match(e, "color grating")) {
            ColorGridFrame w = new ColorGridFrame(f, Geometry.grating);
            w.setTitle((String) e.arg);
        }

        if (Evt.match(e, "Fonts")) {
            AppletUtil.run(new FontViewer());
        }

        if (Evt.match(e, "step size")) {
            IntDialog w = new IntDialog(
                    "Step Size dialog",
                    "Enter Step Size  in pixels:",
                    Geometry.step_size
            );
        }

        if (Evt.match(e, "rotation")) {
            DoubleDialog w = new DoubleDialog(
                    "rotation dialog",
                    "Enter rotation  in degs:",
                    c.rotation
            );
        }
        if (Evt.match(e, "A")) {
            DoubleDialog w = new DoubleDialog(
                    "A dialog",
                    "Enter A  in mms:",
                    c.A
            );
        }
        if (Evt.match(e, "F")) {
            DoubleDialog w = new DoubleDialog(
                    "F dialog",
                    "Enter F  in mms:",
                    c.F
            );
        }
        if (Evt.match(e, "ax**+x/2+c")) {
            DoubleDialog adlg = new DoubleDialog(
                    "a dialog",
                    "a x**2+ x/2+c, a=",
                    g.getPitch2()
            );
            DoubleDialog cdlg = new DoubleDialog(
                    "c dialog",
                    "a x**2+ x/2+c, c=",
                    g.getPitch1()
            );


        }

        if (Evt.match(e, "Grid")) {
            IntDialog w = new IntDialog(
                    "Grid dialog",
                    "Enter Grid width in mms:",
                    Geometry.grid.width
            );
        }
        if (Evt.match(e, "Lambda")) {
            IntDialog w = new IntDialog(
                    "Lambda dialog",
                    "Enter lambda:",
                    Geometry.lambda
            );

        }

        if (Evt.match(e, "open")) {
            f.open();
            return;
        }

        if (Evt.match(e, "white")) {
            f.setForeground(Color.white);
            return;
        }

        if (Evt.match(e, "red")) {
            f.setForeground(Color.red);
            return;
        }

        if (Evt.match(e, "blue")) {
            f.setForeground(Color.blue);
            return;
        }

        if (Evt.match(e, "pink")) {
            f.setForeground(Color.pink);
            return;
        }
        if (Evt.match(e, "green")) {
            f.setForeground(Color.green);
            return;
        }

        if (Evt.match(e, "Grid toggle")) {
            Geometry.grid.toggleVisible();
            return;
        }

        if (Evt.match(e, "list_set_up")) {
            Geometry.print();
            return;
        }

        if (Evt.match(e, "parse_commands")) {
            StringUtil.parseCommands();
            return;
        }

        if (Evt.match(e, "save")) {
            Geometry.save();
            return;
        }

        if (Evt.match(e, "filter_file_hrefs")) {
            Futil.filterFileHrefs();
            return;
        }

        if (Evt.match(e, "process_java")) {
            Futil.processJava();
            return;
        }

        if (Evt.match(e, "make_toc_html")) {
            Futil.makeTocHtml();
            return;
        }


        if (Evt.match(e, "ls")) {
            Ls.toConsole();
            return;
        }

        if (Evt.match(e, "ls word print merge")) {
            Ls.WordPrintMerge();
            return;
        }
        if (Evt.match(e, "delete class files")) {
            Ls.deleteWildFiles("class");
            return;
        }

        if (Evt.match(e, "list_dirs")) {
            Ls.DirsToConsole();
            return;
        }
        if (Evt.match(e, "cat *.java")) {
            try {
                Cat.javasToFile();
            } catch (IOException ex) {
            }
            ;
            return;
        }

        if (Evt.match(e, "ls_htmls")) {
            Ls.wildToConsole(".html");
            return;
        }
        if (Evt.match(e, "ls_gifs")) {
            Ls.wildToConsole(".gif");
            return;
        }

        if (Evt.match(e, "ls_javas")) {
            Ls.wildToConsole(".java");
            return;
        }

        if (Evt.match(e, "filter_htmls")) {
            Futil.filterHtmls();
            return;
        }

        if (Evt.match(e, "save as pict")) {
            Component c = f;
            OutputStream os = Futil.getWriteFileOutputStream();
            //SavePICT p = new SavePICT();
            //p.saveAsPict( c,os);
            return;
        }


    } // objects


}
