package gui;

import java.awt.*;

// Applet to Application Frame window

public class ClosableFrame extends Frame {

    public static void main(String args[]) {
        ClosableFrame cf = new ClosableFrame("Closable Frame");
        cf.show();
    }

    public void paint(Graphics g) {
        g.drawString("Closable Frame", 50, 50);
    }

// constructor needed to pass
// window title to class Frame
    public ClosableFrame(String name) {
        // call java.awt.Frame(String) constructor
        super(name);
    }

// needed to allow window close
    public boolean handleEvent(Event e) {
// Window Destroy event
        if (e.id == Event.WINDOW_DESTROY) {
            dispose();
            return true;
        }

        // it's good form to let the super class
        // look at any unhandled events
        return super.handleEvent(e);

    }  // end handleEvent()

    public MenuItem addMenuItem(Menu aMenu, String itemName) {
        MenuItem mi = new MenuItem(itemName);
        aMenu.add(mi);
        return (mi);
    }

}   // end class ClosableFrame

