package gui;

import java.awt.*;

class ShortCutFrame extends ClosableFrame {
    ShortCutFrame(String title) {
        super(title);
    }

    private static String getModifiers(Event e) {
        String s = "[";
        // clear the modifiers from the key code
        if ((Event.CTRL_MASK & e.modifiers) != 0) s += "^";
        if ((Event.META_MASK & e.modifiers) != 0) s += "M-";
        if ((Event.ALT_MASK & e.modifiers) != 0) s += "A-";
        s = s + (char) e.key + "]";
        return s;
    }

    public static boolean match(Event e, MenuItem mi) {
        if (e.target == mi) return true;
        if (e.id != Event.KEY_PRESS) return false;
        String s = mi.getLabel();
        return s.startsWith(getModifiers(e));
    }
}