package ipl;

import futils.Futil;
import gui.ClosableFrame;
import gui.Evt;
import observers.DoubleDialog;
import observers.IntDialog;
import observers.ObservableDouble;
import observers.ObservableInt;

import java.awt.*;


public class ImageFrame extends ClosableFrame {

    private static final double DEGTORAD = Math.PI / 180;
    private Image image;
    private ImageFrame childFrame;

    ProcessPlane pp;

    // Starx,starty are the frame origin
    private static int startx = 0;
    private static int starty = 0;
    private final int offset = 10;
    // offset is the amount the frame is moved upon
    // creation with respect to the last frame.

    private String args[] = {"ImageFrame"};

    private String fileName;

    private ObservableDouble multKonst = new ObservableDouble(1.0, "mult:");
    private ObservableDouble addKonst = new ObservableDouble(0.0, "add:");
    private ObservableInt threshholdKonst = new ObservableInt(128, "Threshold:");
    private ObservableInt scaleKonst = new ObservableInt(1, "Scale:");

    private ObservableInt startFrame = new ObservableInt(1, "startFrame:");
    private ObservableInt endFrame = new ObservableInt(1, "endFrame:");
    private DoubleDialog multDialog = new DoubleDialog("Multiply Dialog",
            "* k", multKonst);
    private DoubleDialog addDialog = new DoubleDialog("Add Dialog",
            "+ offset", addKonst);
    private IntDialog threshDialog = new IntDialog("Threshold Dialog",
            "Threshold constant", threshholdKonst);
    private IntDialog scaleKonstDialog = new IntDialog("Scale Dialog",
            "Integer Scale constant", scaleKonst);
    private IntDialog startFrameDialog = new IntDialog("startFrameDialog",
            "Integer Scale constant", startFrame);
    private IntDialog endFrameDialog = new IntDialog("endFrameDialog",
            "Integer Scale constant", endFrame);


    Menu m = new Menu("Image");
    Menu am = new Menu("Affine Xforms");
    Menu fm = new Menu("File");
    Menu filterMenu = new Menu("Filter");
    Menu cm = new Menu("Color");

    MenuItem openGIF_mi = addItem("[o]pen GIF or JPEG image", fm);
    MenuItem saveGIF_mi = addItem("[s]ave GIF image", fm);
    MenuItem openPPM_mi = addItem("[p]Open ppm Image", fm);
    MenuItem writePPM_mi = addItem("[w]write ppm Image", fm);
    MenuItem writexy_mi = addItem("[y]write xy file", fm);
    MenuItem revert_mi = addItem("[r]revert to saved", fm);

    MenuItem gray_mi = addItem("[G]ray", cm);
    MenuItem SnellWlx_mi = addItem("[w]ilcox test pattern", cm);
    MenuItem rgb2hls_mi = addItem("[1]RGB to HLS", cm);
    MenuItem hls2rgb_mi = addItem("[!]HLS to RGB", cm);

    MenuItem rgb2hsv_mi = addItem("[2]RGB to HSV", cm);
    MenuItem hsv2rgb_mi = addItem("[@]HSV to RGB", cm);
    MenuItem rgb2cmy_mi = addItem("[3]RGB to CMY", cm);
    MenuItem cmy2rgb_mi = addItem("[#]CMY to RGB", cm);
    MenuItem rgb2iyq_mi = addItem("[4]RGB to IYQ", cm);
    MenuItem iyq2rgb_mi = addItem("[$]IYQ to RGB", cm);
    MenuItem brighten_mi = addItem("[B]righten", cm);
    MenuItem autoScale_mi = addItem("[A]utoscale", cm);

    // Filters ------->
    MenuItem fft_mi = addItem("[F]FT", filterMenu);
    MenuItem ifft_mi = addItem("[I]FT", filterMenu);
    MenuItem multFFT_mi = addItem("[M]ult FFT", filterMenu);
    MenuItem noiseFFT_mi = addItem("[N]oise filter FFT", filterMenu);
    MenuItem vs_mi = addItem("[v]s fft", filterMenu);
    MenuItem blur2_mi = addItem("[2]x2 blur", filterMenu);
    MenuItem Sharpen3_mi = addItem("[3]x3 sharpen", filterMenu);
    MenuItem Sharpen5_mi = addItem("[#]5x5 sharpen", filterMenu);
    MenuItem ImpFilter = addItem("[5]x5 Impulse", filterMenu);
    MenuItem gauss7_mi = addItem("[7]x7 gauss", filterMenu);
    MenuItem hat13_mi = addItem("[H]at 13x13", filterMenu);
    MenuItem horizontalSegment_mi
            = addItem("[-]horizontalSegment", filterMenu);
    MenuItem verticalSegment_mi
            = addItem("[|]verticalSegment", filterMenu);


    MenuItem turn_mi = addItem("[t]urn image", am);
    MenuItem zoom_mi = addItem("[z]oom image", am);
    MenuItem shearx_mi = addItem("[5]shearx image", am);
    MenuItem sheary_mi = addItem("[%]sheary image", am);
    MenuItem turnfb_mi = addItem("[6]turn feedback image", am);
    MenuItem zoomfb_mi = addItem("[^]zoom feedback image", am);
    MenuItem shearxfb_mi = addItem("[7]shearx feedback image", am);
    MenuItem shearyfb_mi = addItem("[&]sheary feedback image", am);
    MenuItem zoomss_mi = addItem("[8]Zoom save sequence", am);
    MenuItem rotss_mi = addItem("[(]Rotate save sequence", am);
    MenuItem rot90_mi = addItem("[9]rotate 90 feedback image", am);
    MenuItem Flip_mi = addItem("[f]lip Frame", am);

    MenuItem copy_mi = addItem("[c]Copy image into new frame");
    MenuItem zed_square_mi = addItem("[2]zed_square");


    MenuItem linear_comb_mi = addItem("[*]img * k + offset");
    MenuItem Subimage_mi = addItem("[-]img - childImage");
    MenuItem multimage_mi = addItem("[x]img * childImage");

    MenuItem imageSize_mi = addItem("[s]Size");
    MenuItem histogram_mi = addItem("[h]istogram");
    MenuItem equalize_mi = addItem("[=]equalize");

    // Edge detectors follow --------->
    MenuItem edge_mi = addItem("[e]dge");
    MenuItem roberts_mi = addItem("[R]oberts edge");
    MenuItem sobel_mi = addItem("[S]obel edge");
    MenuItem laplacian_mi = addItem("[L]aplacian edge");
    MenuItem prewitt_mi = addItem("[P]rewitt edge");

    MenuItem diagGray_mi = addItem("[D]iagGray");
    MenuItem cornergray_mi = addItem("[C]ornerGray");
    MenuItem dot_mi = addItem("[d]ot scale radius");
    MenuItem lines_mi = addItem("[l]ines (uses scale)");
    MenuItem chirp_mi = addItem("[c]hirp (uses scale, add)");

    MenuItem negate_mi = addItem("[n]egate");
    MenuItem randRes_mi = addItem("[r]andResample");
    MenuItem shadow_mi = addItem("[^]shadow");

    MenuItem Scale_mi = addItem("[>]Scale");
    MenuItem Threshold_mi = addItem("[T]hreshold");
    MenuItem closeImage_mi = addItem("[w]Close");


    MenuItem xy2vec_mi = addItem("[X]Y2vec");
    MenuItem ordervec_mi = addItem("[O]rder vectors with Dijkstra");
    MenuItem outputDxf_mi = addItem("[p]olygon output->Dxf");

    MenuItem drawVec_mi = addItem("[d]raw vec");
    MenuItem grabPels_mi = addItem("[g]rab pels");
    MenuItem redraw_mi = addItem("[R]edraw");

    public static void main(String args[]) {
        ImageFrame imageFrame =
                new ImageFrame();
    }

    public boolean handleEvent(Event e) {

        if (e.target instanceof Mask) {
            Mask m = (Mask) e.target;
            m.run();
            updateDisplay(pp);
        }
        if (Evt.match(e, verticalSegment_mi)) {
            verticalSegment();
            return true;
        }
        if (Evt.match(e, horizontalSegment_mi)) {
            horizontalSegment();
            return true;
        }
        if (Evt.match(e, hat13_mi)) {
            hat13();
            return true;
        }
        if (Evt.match(e, Sharpen5_mi)) {
            Sharpen5();
            return true;
        }
        if (Evt.match(e, Sharpen3_mi)) {
            Sharpen3();
            return true;
        }

        if (Evt.match(e, ImpFilter)) {
            ImpulseFilter();
            return true;
        }
        if (Evt.match(e, gauss7_mi)) {
            gauss7();
            return true;
        }
        if (Evt.match(e, blur2_mi)) {
            blur2();
            return true;
        }
        if (Evt.match(e, SnellWlx_mi)) {
            SnellWlxPattern();
            return true;
        }

        if (Evt.match(e, prewitt_mi)) {
            prewitt();
            return true;
        }
        if (Evt.match(e, laplacian_mi)) {
            laplacian();
            return true;
        }
        if (Evt.match(e, sobel_mi)) {
            sobel();
            return true;
        }
        if (Evt.match(e, roberts_mi)) {
            roberts();
            return true;
        }
        if (Evt.match(e, outputDxf_mi)) {
            outputDxf();
            return true;
        }
        if (Evt.match(e, rotss_mi)) {
            rotss();
            return true;
        }
        if (Evt.match(e, zoomss_mi)) {
            zoomss();
            return true;
        }
        if (Evt.match(e, rot90_mi)) {
            rot90();
            return true;
        }
        if (Evt.match(e, shearxfb_mi)) {
            shearxfb();
            return true;
        }
        if (Evt.match(e, shearyfb_mi)) {
            shearyfb();
            return true;
        }

        if (Evt.match(e, turnfb_mi)) {
            turnfb();
            return true;
        }
        if (Evt.match(e, zoomfb_mi)) {
            zoomfeedback();
            return true;
        }
        if (Evt.match(e, shearx_mi)) {
            shearx();
            return true;
        }
        if (Evt.match(e, sheary_mi)) {
            sheary();
            return true;
        }
        if (Evt.match(e, writexy_mi)) {
            writexy();
            return true;
        }
        if (Evt.match(e, iyq2rgb_mi)) {
            iyq2rgb();
            return true;
        }
        if (Evt.match(e, rgb2iyq_mi)) {
            rgb2iyq();
            return true;
        }
        if (Evt.match(e, revert_mi)) {
            revert();
            return true;
        }
        if (Evt.match(e, multimage_mi)) {
            multimage();
            return true;
        }
        if (Evt.match(e, chirp_mi)) {
            chirp();
            return true;
        }
        if (Evt.match(e, lines_mi)) {
            lines();
            return true;
        }
        if (Evt.match(e, dot_mi)) {
            dot();
            return true;
        }
        if (Evt.match(e, noiseFFT_mi)) {
            noiseFFT();
            return true;
        }
        if (Evt.match(e, autoScale_mi)) {
            autoScale();
            return true;
        }
        if (Evt.match(e, zoom_mi)) {
            zoom();
            return true;
        }
        if (Evt.match(e, turn_mi)) {
            turn();
            return true;
        }
        if (Evt.match(e, brighten_mi)) {
            brighten();
            return true;
        }
        if (Evt.match(e, cmy2rgb_mi)) {
            cmy2rgb();
            return true;
        }
        if (Evt.match(e, rgb2cmy_mi)) {
            rgb2cmy();
            return true;
        }
        if (Evt.match(e, openGIF_mi)) {
            childFrame = new ImageFrame();
            return true;
        }
        if (Evt.match(e, saveGIF_mi)) {
            saveGIF();
            return true;
        }
        if (Evt.match(e, writePPM_mi)) {
            writePPM();
            return true;
        }
        if (Evt.match(e, openPPM_mi)) {
            openPPM();
            return true;
        }
        if (Evt.match(e, rgb2hsv_mi)) {
            rgb2hsv();
            return true;
        }
        if (Evt.match(e, hsv2rgb_mi)) {
            hsv2rgb();
            return true;
        }
        if (Evt.match(e, hls2rgb_mi)) {
            hls2rgb();
            return true;
        }
        if (Evt.match(e, rgb2hls_mi)) {
            rgb2hls();
            return true;
        }
        if (Evt.match(e, equalize_mi)) {
            equalize();
            return true;
        }

        if (Evt.match(e, multFFT_mi)) {
            multFFT();
            return true;
        }
        if (Evt.match(e, fft_mi)) {
            fft();
            return true;
        }
        if (Evt.match(e, ifft_mi)) {
            ifft();
            return true;
        }
        if (Evt.match(e, redraw_mi)) {
            redraw();
            return true;
        }
        if (Evt.match(e, grabPels_mi)) {
            pp = ProcessPlane.image2ProcessPlane(image);
            return true;
        }
        if (Evt.match(e, ordervec_mi)) {
            ordervec();
            return true;
        }

        if (Evt.match(e, drawVec_mi)) {
            drawVec();
            return true;
        }
        if (Evt.match(e, negate_mi)) {
            negate();
            return true;
        }
        if (Evt.match(e, xy2vec_mi)) {
            xy2vec();
            return true;
        }


        if (Evt.match(e, histogram_mi)) {
            //Histogram w = new Histogram(pp);
            return true;
        } else if (Evt.match(e, zed_square_mi)) {
            zed_square();
            return true;
        } else if (Evt.match(e, Subimage_mi)) {
            Subimage();
            return true;
        } else if (Evt.match(e, linear_comb_mi)) {
            linearComb();
            return true;
        } else if (Evt.match(e, vs_mi)) {
            vs.vsImage.main(args);
            return true;
        } else if (Evt.match(e, cornergray_mi)) {
            cornergray();
            return true;
        } else if (Evt.match(e, diagGray_mi)) {
            diagGray();
            return true;
        } else if (Evt.match(e, gray_mi)) {
            makeGray();
            return true;
        } else if (Evt.match(e, edge_mi)) {
            edge();
            return true;
        } else if (Evt.match(e, randRes_mi)) {
            randResample();
            return true;
        } else if (Evt.match(e, shadow_mi)) {
            shadow();
            return true;
        }

        if (Evt.match(e, Flip_mi)) {
            FlipFrame w = new FlipFrame(image);
            return true;
        }


        if (Evt.match(e, copy_mi)) {
            copy();
            return true;
        } else if (Evt.match(e, Threshold_mi)) {
            threshold();
            return true;
        } else if (Evt.match(e, Scale_mi)) {
            scale();
            return true;
        } else if (Evt.match(e, imageSize_mi)) {
            pp.printSize();
            return true;
        } else if (Evt.match(e, closeImage_mi)) {
            setVisible(false);
            return true;
        } else if (e.id == e.WINDOW_DESTROY) {
            dispose();
            return true;
        }
        return super.handleEvent(e);
    }

    public void dispose() {
        setVisible(false);
        addDialog.setVisible(false);
        threshDialog.setVisible(false);
        multDialog.setVisible(false);
        scaleKonstDialog.setVisible(false);
    }

    public MenuItem addItem(String itemName) {
        MenuItem mi = new MenuItem(itemName);
        m.add(mi);
        return (mi);
    }

    public MenuItem addItem(String itemName, Menu m) {
        MenuItem mi = new MenuItem(itemName);
        m.add(mi);
        return (mi);
    }

    //public void raytrace() {
    //	RayTracer.main(args);
    //}

    public void init_menu() {
        // my menu items
        MenuBar menuBar = new MenuBar();
        // Initialize the menu bar
        menuBar.add(fm);
        menuBar.add(cm);
        menuBar.add(filterMenu);
        menuBar.add(am);
        menuBar.add(m);
        setMenuBar(menuBar);
    }

    public ImageFrame() {
        super("ImageFrame");
        init_menu();
        show();

        openGIF();

        displayImage();

    }

    public ImageFrame(Image image, String s_) {

        super(s_);

        // offset for new frame for tiling of
        // windows.
        startx += offset;
        starty += offset;
        fileName = s_;
        init_menu();
        show();
        pp = ProcessPlane.image2ProcessPlane(image);
        displayImage();
    }

    public void SnellWlxPattern() {
        SnellWlx sw = new SnellWlx();
        sw.init();
        sw.start();
    }


    public void shadow() {
        pp.shadow();
        updateDisplay(pp);
    }

    public void randResample() {
        pp.randResample();
        updateDisplay(pp);
    }

    public void makeGray() {
        pp.makeGray();
        updateDisplay(pp);
    }

    public void edge() {
        pp = pp.edge();
        updateDisplay(pp);
    }

    public void writexy() {
        pp.edgetoxy();
        updateDisplay(pp);
    }

    /**
        Opens a file of vectors and reorders them
        using Dijkstra's algorithm. Then it prompts
        the user for a save file. An O(N**2) implementation.
     */
    public void ordervec() {
        Dijkstra.main(args);
    }

    /**
        Opens a file of xy points and builds a file
        of vectors. The user is prompted for input
        and output file names. An O(N**2) algorithm.
     */
    public void xy2vec() {
        Xy2vec.main(args);
    }

    public void drawVec() {
        DrawLine.main(args);
    }

    public void diagGray() {
        pp.diagGray();
        updateDisplay(pp);

    }

    public void outputDxf() {
        Dxf.outputTest();
    }

    public void cornergray() {
        pp.cornergray();
        updateDisplay(pp);
    }

    public void openPPM() {
        fileName = Futil.getReadFileName();
        pp = ProcessPlane.openPPM(fileName);
        updateDisplay(pp);
    }

    public void revert() {
        pp = ProcessPlane.openGIF(fileName);
        updateDisplay(pp);
    }

    public void openGIF() {
        if (License.weAreLegal) {
            fileName = Futil.getReadFileName();
            pp = ProcessPlane.openGIF(fileName);
            updateDisplay(pp);
        } else
            System.out.println("Please read License.java");
    }

    public void writePPM() {
        pp.writePPM();
        updateDisplay(pp);
    }

    public void negate() {
        pp.negate();
        updateDisplay(pp);
    }

    public void saveGIF() {
        if (License.weAreLegal) {
            pp.saveGIF();
            updateDisplay(pp);
        } else
            System.out.println("Please read License.java");
    }


    public void rgb2iyq() {
        pp.rgb2iyq();
        updateDisplay(pp);
    }

    public void iyq2rgb() {
        pp.iyq2rgb();
        updateDisplay(pp);
    }

    public void rgb2cmy() {
        pp.rgb2cmy();
        updateDisplay(pp);
    }

    public void cmy2rgb() {
        pp.cmy2rgb();
        updateDisplay(pp);
    }

    public void rgb2hls() {
        pp.rgb2hls();
        updateDisplay(pp);
    }

    public void hls2rgb() {
        pp.hls2rgb();
        updateDisplay(pp);
    }

    public void rgb2hsv() {
        pp.rgb2hsv();
        updateDisplay(pp);
    }

    public void hsv2rgb() {
        pp.hsv2rgb();
        updateDisplay(pp);
    }


    public void equalize() {
        pp.equalize();
        updateDisplay(pp);
    }

    public void fft() {
        pp.fft();
        updateDisplay(pp);
    }

    public void multFFT() {
        pp.multFFT(childFrame.pp);
        updateDisplay(pp);
    }

    public void ifft() {
        pp.ifft();
        updateDisplay(pp);
    }

    public void updateDisplay(PixelPlane pp) {
        updateImage(pp.makeImage());
        repaint();
    }

    public void copy() {
        childFrame = new ImageFrame(
                pp.makeImage(), "child of" + fileName);
    }

    public void zed_square() {

    }

    public void noiseFFT() {
        pp.noiseFFT(multKonst.getValue());
        updateDisplay(pp);
    }

    public void multimage() {

        pp.multimage(childFrame.pp);
        updateDisplay(pp);
    }

    public void linearComb() {

        pp.linearComb(multKonst.getValue(), addKonst.getValue());
        updateDisplay(pp);
    }

    public void dot() {
        Rectangle dim = bounds();
        pp.dot(
                dim.width / 2,
                dim.height / 2,
                scaleKonst.getValue()
        );
        updateDisplay(pp);
    }

    public void lines() {
        pp.lines(bounds(), scaleKonst.getValue());
        updateDisplay(pp);
    }

    public void chirp() {
        pp.chirp(bounds(), scaleKonst.getValue(), addKonst.getValue());
        updateDisplay(pp);
    }


    public void Subimage() {
        if (childFrame == null) {
            System.out.println("You must have a child image");
            return;
        }
        pp.Subimage(childFrame.pp);
        updateDisplay(pp);
    }


    public void threshold() {
        pp.threshold(threshholdKonst.getValue());
        updateDisplay(pp);
    }

    public void scale() {
        pp = pp.scale(scaleKonst.getValue());
        updateDisplay(pp);
    }

    public void brighten() {
        pp.brighten(multKonst.getValue());
        updateDisplay(pp);
    }

    public void autoScale() {
        pp.autoScale();
        updateDisplay(pp);
    }


    public void turn() {
        pp.turn(multKonst.getValue());
        updateDisplay(pp);
    }

    public void zoom() {
        pp.zoom(multKonst.getValue());
        updateDisplay(pp);
    }

    public void rotss() {
        String dir = Futil.getWriteDirectoryName();
        int sf = startFrame.getValue();
        int ef = endFrame.getValue();
        for (int i = sf; i < ef; i++) {
            pp.turnfb(multKonst.getValue());
            updateDisplay(pp);
            pp.writePPM(dir + "image" + i);
            System.out.println("loop:" + i);
        }
    }

    public void zoomss() {
        String dir = Futil.getWriteDirectoryName();
        int sf = startFrame.getValue();
        int ef = endFrame.getValue();
        for (int i = sf; i < ef; i++) {
            pp.zoomfeedback(multKonst.getValue());
            updateDisplay(pp);
            pp.writePPM(dir + "image" + i);
            System.out.println("loop:" + i);
        }
    }

    public void zoomfeedback() {
        for (int i = 0; i < scaleKonst.getValue(); i++) {
            pp.zoomfeedback(multKonst.getValue());
            updateDisplay(pp);
            System.out.println("loop:" + i);
        }
    }

    public void turnfb() {
        for (int i = 0; i < scaleKonst.getValue(); i++) {
            pp.turnfb(multKonst.getValue());
            updateDisplay(pp);
            System.out.println("loop:" + i);
        }

    }

    public void rot90() {
        pp.turnfb(90);
        updateDisplay(pp);
    }

    public void shearxfb() {
        pp.shearxfb(multKonst.getValue());
        updateDisplay(pp);
    }

    public void shearyfb() {
        pp.shearxfb(multKonst.getValue());
        updateDisplay(pp);
    }

    public void shearx() {
        pp.shearx(multKonst.getValue());
        updateDisplay(pp);
    }

    public void sheary() {
        pp.sheary(multKonst.getValue());
        updateDisplay(pp);
    }

    public void displayImage() {
        image = pp.makeImage();
        resize(
                image.getWidth(this), image.getHeight(this));
        //set image title
        setTitle(fileName);
        show();
    }

    public void updateImage(Image image_) {
        image = image_;
        waitForImage(this, image_);
        show();
    }

    private static void waitForImage(Component component,
                                     Image image) {
        MediaTracker tracker = new MediaTracker(component);
        try {
            tracker.addImage(image, 0);
            tracker.waitForAll();
            tracker.waitForID(0);
            if (tracker.checkID(0))
                System.out.println("The image checked as loaded");
            else
                System.out.println("Load failure!");
        } catch (InterruptedException e) {
            Assert.notNull(null);
        }
    }

    public void redraw() {
        updateDisplay(pp);
    }


    public void paint(Graphics g) {
        if (image == null)
            image = pp.makeImage();
        g.drawImage(image, 0, 0, this);
    }

    private void roberts() {
        pp.makeGray();
        pp = pp.roberts();
        updateDisplay(pp);
    }

    private void sobel() {
        pp.makeGray();
        pp = pp.sobel();
        updateDisplay(pp);
    }

    private void laplacian() {
        pp.makeGray();
        pp = pp.laplacian();
        updateDisplay(pp);
    }

    private void gauss7() {
        pp.gauss7();
        updateDisplay(pp);
    }


    private void Sharpen3() {
        pp.Sharpen3();
        updateDisplay(pp);
    }

    private void Sharpen5() {
        pp.Sharpen5();
        updateDisplay(pp);
    }

    private void ImpulseFilter() {
        pp.ImpulseFilter();
        updateDisplay(pp);
    }

    private void blur2() {
        pp.blur2();
        updateDisplay(pp);
    }

    private void verticalSegment() {
        pp.verticalSegment();
        updateDisplay(pp);
    }

    private void horizontalSegment() {
        pp.horizontalSegment();
        updateDisplay(pp);
    }

    private void hat13() {
        pp.hat13();
        updateDisplay(pp);
    }

    private void prewitt() {
        pp.makeGray();
        pp = pp.prewitt();
        updateDisplay(pp);
    }

}

