package ipl;

import futils.Print;

public class Point3d {
    double x = 0;
    double y = 0;
    double z = 0;

    public Point3d(double new_x, double new_y, double new_z) {
        x = new_x;
        y = new_y;
        z = new_z;
    }

    public Point3d(Point3d np) {
        x = np.x;
        y = np.y;
        z = np.z;
    }

    // C = A dot B, return C
    public double dot(Point3d b) {
        return x * b.x + y * b.y + z * b.z;
    }

    // C = a * A + B, return C
    public Point3d comb(double a, Point3d b) {
        return new Point3d(a * x + b.x, a * y + b.y, a * z + b.z);
    }

    // A = -A
    public void negate() {
        x = -x;
        y = -y;
        z = -z;
    }

    // C = A - B, return C
    public Point3d sub(Point3d b) {
        return new Point3d(x - b.x, y - b.y, z - b.z);
    }

    // C = A + B, return C
    public Point3d add(Point3d b) {
        return new Point3d(x + b.x, y + b.y, z + b.z);
    }

    // makes the vector a unit vector
    public void normalize() {
        double a;
        a = magnitude();
        x = x / a;
        y = y / a;
        z = z / a;
    }

    public double magnitude() {
        return Math.sqrt(x * x + y * y + z * z);
    }

    public void println() {
        System.out.print(this.getClass().getName() + " = ");
        Print.ln("\t" + x + "\t" + y + "\t" + z);
    }

    public void test() {
        Point3d p1 = new Point3d(3, 2, 3);
        Point3d p2 = new Point3d(0, 3, 9);
        Point3d p3 = p1.comb(0.5, p2);

        System.out.print("p1 = ");
        p1.println();
        System.out.println("The magnitude of p1 = " + p1.magnitude());
        System.out.print("p2 = ");
        p2.println();
        System.out.print("p3 = ");
        p3.println();
    }

}
