package surfer;

/******************************************************************************************

 * Surface Plotter version 1.20                                               Nov  8 1996 *

 *                                                                                        *

 * SurfaceLogo.java: Logo of Surface Plotter                                              *

 *                                                                                        *

 * Copyright (c) 1996 Yanto Suryono. All Rights Reserved.                                 *

 *                                                                                        *

 * Permission to use, copy, and distribute this software for NON-COMMERCIAL purposes      *

 * and without fee is hereby granted, provided that this copyright notice appears in all  *

 * copies and this software is not modified in any way                                    *

 *                                                                                        *

 * Please send bug reports and/or corrections/suggestions to                              *

 * Yanto Suryono <d0771@cranesv.egg.kushiro-ct.ac.jp>                                     *

 ******************************************************************************************/


import java.awt.*;


public class SurfaceLogo extends Panel {

    private final int SPACE = 10;


    SurfaceLogo() {

        super();

    }


    public void addNotify() {

        super.addNotify();

        setFont(new Font(getFont().getName(), Font.BOLD, getFont().getSize() + 1));

    }


    public void paint(Graphics g) {

        FontMetrics fm = g.getFontMetrics(g.getFont());

        int leveladjust = (bounds().height - 4 - 2 * fm.getAscent()) / 4,x,y;


        x = (bounds().width - fm.stringWidth(Surface.APP_NAME)) / 2;

        y = bounds().height / 2 - leveladjust;


        g.setColor(Color.black);

        g.drawString(Surface.APP_NAME, x, y);

        g.setColor(Color.white);

        g.drawString(Surface.APP_NAME, x - 1, y - 1);


        x = (bounds().width - fm.stringWidth(Surface.APP_VERSION)) / 2;

        y = bounds().height - 3 - leveladjust;


        g.setColor(Color.black);

        g.drawString(Surface.APP_VERSION, x, y);

        g.setColor(Color.yellow);

        g.drawString(Surface.APP_VERSION, x - 1, y - 1);


        g.setColor(Color.lightGray);

        g.draw3DRect(0, 0, bounds().width - 1, bounds().height - 1, false);

        g.draw3DRect(1, 1, bounds().width - 3, bounds().height - 3, false);

    }


    public Dimension preferredSize() {

        Graphics g = getGraphics();

        FontMetrics fm = g.getFontMetrics(g.getFont());

        g.dispose();


        return new Dimension(fm.stringWidth(Surface.APP_NAME) + 2 * SPACE, 0);

    }

}





