package vs;

import ipl.Mat3;
import ipl.ProcessPlane;

// refer to ITU-R BT.601 (Formerly: CCIR 601)


public class YUV extends ColorConverter {

    double A[][] = {
        {0.300, 0.590, 0.110},
        {0.600, -0.280, -0.320},
        {0.210, 0.520, 0.310}
    };

    Mat3 rgb2yuvMat = new Mat3(A);
    Mat3 yuv2rgbMat = rgb2yuvMat.invert();

    public YUV(ProcessPlane pp_) {
        super(pp_);
    }

    public int[] fromRGB() {
        double pel[];
        float r, g, b;

        for (int i = 0; i < fi.r.length; i++) {
            pel = rgb2yuvMat.multiply(fi.r[i], fi.g[i], fi.b[i]);

            fi.r[i] = (float) pel[0];
            fi.g[i] = (float) pel[1];
            fi.b[i] = (float) pel[2];
            pp.setPixel(i, (int) pel[0], (int) pel[1], (int) pel[2], 255);
        }

        return (pp.pels);
    }

    public int[] toRGB() {
        float y, u, v;
        double pel[];

        for (int i = 0; i < fi.r.length; i++) {

            pel = yuv2rgbMat.multiply(fi.r[i], fi.g[i], fi.b[i]);

            fi.r[i] = (float) pel[0];
            fi.g[i] = (float) pel[1];
            fi.b[i] = (float) pel[2];
            pp.setPixel(i, (int) pel[0], (int) pel[1], (int) pel[2], 255);

        }

        return (pp.pels);
    }

}







